<?php

namespace FiloBlu\Flow\Cron;

class Fetch
{
    protected $_logger;
    protected $_processor;

    public function __construct(
            \Psr\Log\LoggerInterface $logger, 
            \FiloBlu\Flow\Model\Processor $processor) {
        $this->_logger = $logger;
        $this->_processor = $processor;
    }

    public function execute() {
        $this->_logger->info(__METHOD__);
        $this->_processor->fetchChannels();
        return $this;
    }
    
    public function receive() {
        $this->_logger->info(__METHOD__);
        $this->_processor->receiveData();
        return $this;
    }
    
    public function parse() {
        $this->_logger->info(__METHOD__);
        $this->_processor->parse();
        return $this;
    }
    
    public function process() {
        $this->_logger->info(__METHOD__);
        $this->_processor->processNormal();
        return $this;
    }
    
}

