<?php
/**
 * Copyright © 2015 FiloBlu . All rights reserved.
 */
namespace FiloBlu\Flow\Helper;

class Attribute extends \Magento\Framework\App\Helper\AbstractHelper
{

    protected $_connection;
    protected $_setup;

    public function addAttributeOption($option)
    {
        $optionTable = $this->getSetup()->getTable('eav_attribute_option');
        $attributeId = $option['attribute_id'];
        $optionValue = $option['value'];
        $storeId = $option['store_id'];

        if(empty($optionValue)){
            Mage::throwException("Option value cannot be empty");
        }

        if($storeId != 0){
            Mage::throwException("I can only add option for admin store view");
        }

        if(empty($attributeId)){
            Mage::throwException("Attribute id has to be defined when adding an option");
        }
        // add option
        $data = array(
            'attribute_id' => $option['attribute_id']
        );
        $this->getConnection()->insert($optionTable, $data);
        $optionId =  $this->getConnection()->lastInsertId($optionTable);
        if(empty($optionId)){
            return false;
        }
        $optionValueTable   = $this->getSetup()->getTable('eav_attribute_option_value');
        $option['option_id']=$optionId;
        unset($option['attribute_id']);
        $this->getConnection()->insert($optionValueTable, $option);
        return $optionId;
    }

    public function addAttributeTranslation($option){
        $optionId = $option['option_id'];
        $optionValue = $option['value'];
        $storeId = $option['store_id'];

        if(empty($optionValue)){
            Mage::throwException("Option value cannot be empty");
        }

        if(empty($storeId)){
            Mage::throwException("I can't add translation for default store view");
        }

        if(empty($optionId)){
            Mage::throwException("I can't add translation for unknown option");
        }

        $optionValueTable   = $this->getSetup()->getTableName('eav_attribute_option_value');
        //we'd might update
        $select = $this->getConnection()->select()
            ->from($optionValueTable)
            ->where('option_id = '.$optionId)
            ->where('store_id = '.$storeId);

        $result = $this->getConnection()->fetchRow($select);
        if ($result) {
            $where = array('option_id =?' => $option['option_id'],
                'store_id =?' => $option['store_id']);
            $this->getConnection()->update($optionValueTable, $option, $where);
            return true;
        }
        $this->getConnection()->insert($optionValueTable, $option);
        return true;
    }

    protected function getSetup(){
        if(empty($this->_setup)){
            $this->_setup = \Magento\Framework\App\ObjectManager::getInstance()->get('\Magento\Framework\App\ResourceConnection');
        }
        return $this->_setup;
    }

    protected function getConnection(){
        if(empty($this->_connection)){
            $this->_connection = $this->getSetup()->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        }
        return $this->_connection;
    }

}