<?php

namespace FiloBlu\Flow\Model\Actions\From;

class Name {

    CONST ENTITY_TYPE_CODE = 'catalog_product';

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Product $helper_product,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        $this->helper_product = $helper_product;
    }

    public function process($product, $value, $storeId) {
        if(empty($value)){
            return true;
        }

        $fatherProductsIds = $this->helper_product->getParentProductsIds(array($product->getId()));
        if(!empty($fatherProductsIds)){
            foreach($fatherProductsIds as $fatherProductId){
                $fatherProduct = Mage::getModel('catalog/product')->setStoreId($storeId)->load($fatherProductId);
                if($fatherProduct->getUrlKey() != $fatherProduct->formatUrlKey($value)){
                    self::setProductName($fatherProduct, $value, $storeId);
                }
            }
        }

        self::setProductName($product, $value, $storeId);
        return true;
    }

    protected static function setProductName($product, $name, $storeId){
        $urlKey = $product->formatUrlKey($name);

        $pids = array($product->getId());
        $attributesData = array('name' => $name, 'url_key' => $urlKey);

        try{
            \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                ->updateAttributes($pids, $attributesData, $storeId);
//            Mage::getSingleton('catalog/product_action')->updateAttributes($pids,$attributesData, $storeId);
        }catch (\Exception $e){
            $message = "Problem while processing eavs, <br/> store id : ".$storeId."<br/> pids : ".print_r($pids,true). "<br/> attribute data : ".print_r($attributesData,true);
            $message .= "<br/> \Exception : ".$e->getMessage();
            $message .= "<br/> Backtrace : <br/> ".nl2br($e->getTraceAsString());
            FiloBlu_Flow_Model_From_Eavs::sendErrorEmail($message);
            Mage::throwException($e->getMessage());
        }

//        $urlModel = Mage::getSingleton('catalog/url');
//        $urlModel->setShouldSaveRewritesHistory($product->getStatus() == Mage_Catalog_Model_Product_Status::STATUS_ENABLED);
//        if ($storeId == 0) {
//            $urlModel->refreshProductRewrite($product->getId());
//        }
//        else {
//            $urlModel->refreshProductRewrite($product->getId(), $storeId);
//        }
    }

}
