<?php
namespace FiloBlu\Flow\Model\Channel;

class Config{

    public $initialized = false;
    public $file = "map.json";
    protected $mappedData = array();
    public $log;

    public function load($channel) {

        $model_channel = \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model\Channel');
        $model_channel->load($channel,'name');

        $this->log =  \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model\Log');

        if($model_channel){

            try {
                $json_content = str_replace(array("\n", "\t", "\r"), '', $model_channel->getData('data'));
                $mapped_config = json_decode($json_content,true);
                //$mapped_config->map = null;
                $this->mappedData = $mapped_config;
                $this->initialized = true;
                $this->log->log("Config","Loaded map json file");
            }catch(\Exception $e){
                $this->log->log("Config","Fail to load map json file");
            }
        }else{
            $this->log->log("Config","File for channel data not exist for json map");
        }

    }

    public function get($field){
        if(isset($this->mappedData[$field])){
            return $this->mappedData[$field];
        }
        return null;
    }

    public function getFields(){
        return array_keys($this->mappedData);
    }

    public function checkData($data){
        if(count($data) == count($this->mappedData)){
            return true;
        }
        return false;
    }

}