<?php

namespace FiloBlu\Flow\Model\Channel\In;

class Anagrafica extends AbstractModel {


    public function __construct(){
        $this->init('anagrafica');
    }

    public function insertData($data){

        $flow = $this->getFile()->getData('flow');
        $model =  \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model' . "\\" . $flow);

        if (!$model)
            return false;

        $resource = \Magento\Framework\App\ObjectManager::getInstance()->create('\Magento\Framework\App\ResourceConnection');

        $writeConnection = $resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $tableName = $resource->getTableName('flow_from_eavs');


        $meta_file = $this->getFile()->getId();
        $codice_articolo = $data['sku'];
        $writeConnection->beginTransaction();
        $actions = array();
        $noDuplicate = array('_translate_attribute', '_add_related', '_add_upsells', '_add_crosssells');

        $query = "INSERT INTO {$tableName} (e,a,v,s,meta_file,meta_ref_id,meta_processed,meta_insert_time) VALUES (:e,:a,:v,:s,:meta_file,:meta_ref_id,:meta_processed,:meta_insert_time)";
        foreach($data as $field => $value){
            $fieldMap = $this->map->get($field);
            if(!isset($fieldMap["skip"]) && trim($value) != '') {
                $to_field = "";
                if(isset($fieldMap["to"])) {
                    $to_field = $fieldMap["to"];
                    if(!isset($fieldMap['actions']) || !in_array('_translate_attribute',$fieldMap['actions'])) {
                        //devo inserire una riga per ogni attributo
                        $bind = array(
                            'e' => $codice_articolo,
                            'a' => $to_field,
                            'v' => $value,
                            'meta_file' => $meta_file,
                            's' => '',
                            'meta_ref_id' => 0,
                            'meta_processed' => 0,
                            'meta_insert_time' => date("Y-m-d H:i:s", time())
                        );
                        if (isset($fieldMap["stores"]) && count($fieldMap["stores"]) > 0 && $fieldMap["stores"]) {
                            foreach ($fieldMap["stores"] as $store) {
                                $bind['s'] = $store;
                                $writeConnection->query($query, $bind);
                            }
                        } else if (isset($fieldMap["locale"]) && $fieldMap["locale"] && $fieldMap["locale"]) {
                            $storeViews = $this->_getStoresCodeByLocale($fieldMap["locale"]);
                            foreach ($storeViews as $store) {
                                $bind['s'] = $store;
                                $writeConnection->query($query, $bind);
                            }
                        } else {
                            $writeConnection->query($query, $bind);
                        }
                    }
                }
                //le azioni le conservo per inserirle alla fine
                if(isset($fieldMap["actions"])){
                    foreach($fieldMap["actions"] as $action){
                        $a = array("value" => $value,"stores" => array());
                        if(isset($to_field) && $action == '_translate_attribute'){
                            $a['e'] = $to_field;
                        }
                        if(isset($fieldMap["locale"]) && count($fieldMap["locale"]) > 0 && $fieldMap["locale"]) {
                            $storeViews = $this->_getStoresCodeByLocale($fieldMap["locale"]);
                            foreach ($storeViews as $store) {
                                $a['stores'][] = $store;
                            }
                        }

                        if(isset($fieldMap["stores"]) && count($fieldMap["stores"]) > 0 && $fieldMap["stores"]) {
                            $a['stores'] = $fieldMap["stores"];
                        }

                        $actions[$action][] = $a;
                    }
                }
            }

        }
        foreach($actions as $a => $values){
            foreach($values as $v) {
                if(in_array($a, array('_add_related', '_add_upsells', '_add_crosssells'))){
                    $padre = explode('#',$data['cod_configurabile']);
                    $bind = array(
                        'e' => $padre[0],
                        'a' => $a,
                        'v' => $v['value'],
                        'meta_file' => $meta_file,
                        's' => '',
                        'meta_ref_id' => (isset($v['e']) ? 1 : 0),
                        'meta_processed' => 0,
                        'meta_insert_time' => date("Y-m-d H:i:s", time())
                    );
                }
                else{
                    $bind = array(
                        'e' => (isset($v['e']) ? $v['e'] : $codice_articolo),
                        'a' => $a,
                        'v' => $v['value'],
                        'meta_file' => $meta_file,
                        's' => '',
                        'meta_ref_id' => (isset($v['e']) ? 1 : 0),
                        'meta_processed' => 0,
                        'meta_insert_time' => date("Y-m-d H:i:s", time())
                    );
                }
                try {
                    if (count($v['stores']) > 0) {
                        $storeViews = $v['stores'];
                        foreach ($storeViews as $store) {
                            $bind['s'] = $store;
                            if (in_array($bind['a'], $noDuplicate)) {
                                if ($this->checkDuplicates($tableName, $bind)) {
                                    //Evito l'inserimento di duplicati
                                    continue;
                                }
                            }
                            $writeConnection->query($query, $bind);
                        }
                    } else {
                        if (in_array($bind['a'], $noDuplicate)) {
                            if ($this->checkDuplicates($tableName, $bind)) {
                                //Evito l'inserimento di duplicati
                                continue;
                            }
                        }
                        $writeConnection->query($query, $bind);
                    }
                } catch (\Exception $e) {
                    throw new \Exception($e->getMessage());
                }
            }
        }
        $writeConnection->commit();
    }

    public function receiveFile($file){

        if (!$this->_connector)
            throw new \Exception('no connector joined to channel');

        $ite = 'ite';//(Array) Mage::getConfig()->getNode('processor/channels/in')->ite;

        if($ite){
            $received = $this->_connector->receiveResource($file->getName(),"ite_".date('Ymd_Hmi'));
        }else{
            $received = $this->_connector->receiveResource($file->getName());
        }
        //Se ho copiato il fine creo una riga per il flusso
        if(is_array($received)){
            $copy = $received['copy'];
            $received = $received['basefile'];
            $model = \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model\Inboundflow');;
            $model->setName($copy);
            $model->setFlow('From\Product');
            $model->setType('file');
            $model->setChannel('ite');
            $model->setRetry(0);
            $model->setStatus('received');
            $model->setPriority('normal');
            try{
                $model->save();
            }catch (\Exception $e){
                Mage::log($e->getMessage());
            }
        }
        elseif ($received === false) {
            throw new \Exception('no remote files found');
        }
        return $received;

    }

    protected function _getStoresCodeByLocale($locale){
        if(count($this->_storesByLocale) == 0) {
            $stores = Mage::app()->getStores();
            foreach($stores as $store){
                $localeCode = Mage::getStoreConfig('general/locale/code', $store->getId());
                if(!isset($this->_storesByLocale[$localeCode])){
                    $this->_storesByLocale[$localeCode] = array();
                }
                $this->_storesByLocale[$localeCode][] = $store->getCode();
            }
        }
        if(isset($this->_storesByLocale[$locale])){
            return $this->_storesByLocale[$locale];
        }
        return array();
    }

    protected function checkDuplicates($tableName,$bind){
        $resource = \Magento\Framework\App\ObjectManager::getInstance()->create('\Magento\Framework\App\ResourceConnection');
        $readConnection = $resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);

        $query = "SELECT count(*) FROM {$tableName} WHERE e = '{$bind["e"]}' AND a = '{$bind["a"]}' AND v = '{$bind["v"]}' AND meta_file = '{$bind["meta_file"]}' AND s = '{$bind["s"]}'";
        $result = $readConnection->fetchOne($query);
        if($result > 0){
            return true;
        }
        return false;
    }
}
