<?php
namespace FiloBlu\Flow\Model\Parser;

class Csv extends AbstractParser {
    public $map;
    public $pointer;
    private $linesToSkip = 0;
    private $separator = ";";
    private $delimiter = '"';

    public function __construct(){
        parent::__construct();
    }

    public function setConfig($config)
    {
        $this->_config = $config;

        $this->separator = (String) @$this->_config['separator'];
        $this->delimiter = (String) @$this->_config['delimiter'];
        $this->linesToSkip = (String) @$this->_config['linesToSkip'];

    }

    public function process($resource){
        $returnArray = array();
        $handle = fopen($resource, "r");
        $count = 0;
        while (($data = fgetcsv($handle, 0, $this->separator)) !== false) {
            $count++;

            //Controlli
            if ($count <= $this->linesToSkip) {
                continue;
            }

            try {
                $returnArray[] = $this->parse($data);
            } catch (\Exception $e) {
                throw new \Exception($e->getMessage() . ' at row'  . $count);
            }


        }

        fclose($handle);
        $channel = $this->getChannel();
        if (method_exists($channel, 'commitData') && !is_null($channel)) {
            $committed = $channel->commitData();
        }
        return $returnArray;
    }




}